class Joystick {
  ControllDevice device;
  ControllSlider sliderX;
  ControllSlider sliderY;
  ControllStick stick;
  ControllButton button2, button1;
  int num;
  boolean last_state=false;
  Joystick( ControllDevice device, int num) {
    this.device=device;
    this.num=num;
    this.device.setTolerance(0.1f);
    this.sliderX = this.device.getSlider("X-Achse");
    this.sliderY = this.device.getSlider("Y-Achse");
    this.stick = new ControllStick(this.sliderX,this.sliderY);
    
    this.button1 = this.device.getButton(1);
    this.button2 = this.device.getButton(0);
  }
  
  boolean needUpdate() {
    boolean out=false;
    if (this.stick.getY() != 0 || this.stick.getX() != 0 || this.button1.pressed()||this.button2.pressed()) {
      out=true;
    }
    if (this.last_state && !out) {
      this.last_state=out;
      out=true;
    }
    else {
      this.last_state=out;
    }
    return out;
  }

  String isUp() {
    return this.stick.getY() < 0 ? "1" : "0";
  }
  String isDown() {
    return this.stick.getY() > 0 ? "1" : "0";
  }
  String isLeft() {
    return this.stick.getX() < 0 ? "1" : "0";
  }
  String isRight() {
    return this.stick.getX() > 0 ? "1" : "0";
  }
  String buttonPressed() {
    String out="0";
    if (this.button2.pressed())
      out="1";
    
    if (this.button1.pressed())
      out="1";
    
    return out;
  }
  String getCompleteXML() {
    String out="<joystick_"+this.num;
     out+=" num='"+this.num+"'";
     out+=" up='"+this.isUp()+"'";
     out+=" down='"+this.isDown()+"'";
     out+=" left='"+this.isLeft()+"'";
     out+=" right='"+this.isRight()+"'";
     out+=" pressed='"+this.buttonPressed()+"' />\n";
     return out;
  }
}
